<!-- BEGIN CMVC                                                              -->
<!-- *********************************************************************** -->
<!--                                                                         -->
<!--   Workfile: %W%                                                         -->
<!--   Last update: %E% %U%                                                  -->
<!--   SCCS path, id: %F% %I%                                                -->
<!--                                                                         -->
<!-- *********************************************************************** -->
<!-- END CMVC                                                                -->
<!-- BEGIN COPYRIGHT                                                         -->
<!-- *********************************************************************** -->
<!--                                                                         -->
<!--   Licensed Materials - Property of IBM                                  -->
<!--   WA81 SupportPac                                                       -->
<!--   (c) Copyright IBM Corp. 1999, 2001                                    -->
<!--   US Government Users Restricted Rights - Use, duplication or           -->
<!--   disclosure restricted by GSA ADP Schedule Contract                    -->
<!--   with IBM Corp.                                                        -->
<!--                                                                         -->
<!-- *********************************************************************** -->
<!-- END COPYRIGHT                                                         -->

<%-- Import the context bean that will be passed by the servlet --%>
<%-- Note that the scope of that bean is a single request, not  --%>
<%-- the entire session                                         --%>
<%@ page language="java" info="JSP list Viewer" %>
<%@ page errorPage="ViewError.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.ibm.workflow.api.*" %>
<%@ page import="com.ibm.workflow.api.ProcessInstancePackage.*" %>
<%@ page import="com.ibm.workflow.api.ItemPackage.*" %>
<%@ page import="com.ibm.workflow.servlet.client.*" %>
<jsp:useBean id="context" scope="request"
             type="com.ibm.workflow.servlet.client.RequestContext"/>

<html>
<!-- Create the page title --------------------------------------->
<% String user = context.getUserID();
   String distype = "", refreshCommand = "";
   int count = 0, type = SessionContext.NOT_SET;
   PersistentList list = null;

   if (context.getInstances() != null)
   {
     distype = context.get("ListViewer.ProcessInstances");
     type = SessionContext.INSTANCELIST;
     refreshCommand = "queryProcessInstances";
     count = context.getInstances().length;
     list = context.getInstanceList(context.getInstanceListOid());
   }
   else if (context.getWorkItems() != null)
   {
     distype = context.get("ListViewer.WorkItems");
     type = SessionContext.WORKLIST;
     refreshCommand = "queryWorkItems";
     count = context.getProcessInstanceNotifications().length
           + context.getActivityInstanceNotifications().length
           + context.getWorkItems().length;
     list = context.getWorkList(context.getWorkListOid());
   }
   else if (context.getTemplates() != null)
   {
     distype = context.get("ListViewer.ProcessTemplates");
     type = SessionContext.TEMPLATELIST;
     refreshCommand = "queryProcessTemplates";
     count = context.getTemplates().length;
     list = context.getTemplateList(context.getTemplateListOid());
   }
   else
   {
     distype = context.get("ListViewer.Lists");
     type = SessionContext.LISTS;
     refreshCommand = "queryLists";
     count = context.getNumberOfWorkLists()
                        +context.getNumberOfInstanceLists()
              +context.getNumberOfTemplateLists();
   }
%>
<head>
  <title>
    <%if (type == SessionContext.LISTS) {%>
    <%=context.get("ListViewer.Lists")%> &nbsp;
    <%} else {%>
    <%=context.get("ListViewer.Of", new String[] { distype, list.name() })%>
    <%}%>
  </title>
  <link rel="stylesheet" type="text/css" href="../webclientstyle.css">
  <style type="text/css">
  <!--
    td
    {
      font-size   :8pt;
      font-family :Arial, Helvetica, sans-serif;
    }
    th
    {
      font-size   :10pt;
      font-weight :bold;
    }
  //-->
  </style>

  <script language='JavaScript'>
  function fillForm(doc, name, owner, user, cmd, canEmail)
  {
    doc.open("text/html");
    doc.writeln("<html><head><title><%=context.get("ListViewer.TransferWorkItem")%></title>");
    doc.writeln("<link rel='stylesheet' type='text/css' href='../webclientstyle.css'>");
    doc.writeln("</head><body><form name='data'><div width='100%' class='title'>");
    doc.writeln("<%=context.get("ListViewer.TransferWorkItemToPrefix")%> <i>" + name + "</i> <%=context.get("ListViewer.TransferWorkItemToPostfix")%><br><br></div>");
    doc.writeln("<center><table><tr><label><td><b><%=context.get("ListViewer.UserID")%></b></td><td><input type='text' name='userID' value='" + user + "' size='30'></td></label></tr>");
    if (canEmail == 'true') doc.writeln("<tr><label><td><b><%=context.get("ListViewer.EmailAddress")%></b></td><td><input type='text' name='email' size='30'></td></label></tr>");
    doc.writeln("</table><p><input type='button' value='<%=context.get("ListViewer.Transfer")%>' " +
                "onClick='javascript:if (data.userID.value == &quot;&quot;) alert(&quot;You must provide a User ID&quot;); else { var sub=&quot;" + cmd +
                "&quot; + &quot;&userID=&quot; + data.userID.value" +
                (canEmail == 'true' ? "+ &quot;&email=&quot; + data.email.value;" : ";"));
    doc.writeln("window.opener.location.href = sub; window.close();}'>");
    doc.writeln("<input type='button' value='<%=context.get("Command.Cancel")%>' onClick='javascript:window.close();'></center></p></form></body></html>");
    doc.close();
    doc.data.userID.focus();
  }
  </script>
</head>

<body>

<%=context.openForm(refreshCommand, context.persistentOidOf(list))%>

<table width="100%" border="2" bordercolordark="#000000" bordercolorlight="#FFFFFF" cellpadding="0" cellspacing="0" class="navigator">
  <tr>
  <td align="left" nowrap>
    <!-- Create the navigation combobox ------------------------------>

    <span style="font-size:10pt; font-weight:bold; vertical-align=middle;">&nbsp;<%=context.get("ListViewer.Navigate")%>&nbsp;</span>
      <select name="Navigator" size="1" onChange="var v=options[selectedIndex].value; if (v!=null) location=v;">
      <option selected><%=context.get("ListViewer.SelectAView")%></option>
      <%
        java.util.Vector navigatorEntries =
           (java.util.Vector) context.getAttribute("navigatorEntries");
        for (int i = 0; navigatorEntries != null && i < navigatorEntries.size(); ++i) {
          NavigatorEntry entry =
            (NavigatorEntry) navigatorEntries.elementAt(i); %>
      <option value="<%=entry.getCommand()%>"><%=entry.getName()%></option>
      <% } /* for */ %>
      <%if (type != SessionContext.LISTS) {%>
                        <option value="<%=context.getCommand("queryLists")%>">
        <%=context.get("ListViewer.ShowLists")%></option>
      <%}%>
    </select>
  </td>

  <!-- Add the buttons ----------------------------------------------->
  <td>
    <a href="<%=context.getCommand(refreshCommand, context.persistentOidOf(list))%>">
    <img src="../images/navigation/refresh.gif" border="0" alt="<%=context.get("Command.Refresh")%>"></a></td>

  <td width="100%">&nbsp;</td>

  <td>
     <a href="javascript:{}" onClick="javascript:var helpwin=window.open('../help/Help_index.html','Help','width=600,height=500,screenX=100,screenY=0,scrollbars,resizable');helpwin.frames[1].location.replace('../help/Help_Body.html#<%=refreshCommand%>');">
     <img src="../images/navigation/help.gif" border="0" alt="<%=context.get("ListViewer.Help")%>"></a></td>

  <td class="navigationseparator"><img src="../images/a_pixel.gif" width="3"></td>

  <td align="right">
     <a href="<%=context.getCommand("logoff")%>">
     <img src="../images/navigation/logoff.gif" border="0" alt="<%=context.get("ListViewer.Logoff")%>"></a></td>
  </tr>
</table>

</form>

<div class="navigationinfo" align="right">
  <% /*String linkUser="<a href=\"javascript:{}\" onClick=\"javascript:window.open('"+context.getCommand("getUserInfo")+
        "','UserInformation',   'width=500,height=380,screenX=20,screenY=0')\">";*/
     String linkUser="<a href=\""+context.getCommand("getUserInfo")+"\">";
     String linkSys="<a href=\"javascript:{}\" onClick=\"javascript:window.open('"+context.getCommand("getSystemInfo")+
     "','SystemInformation','width=550,height=305,screenX=100,screenY=0, resizable')\">";%>
  <%=context.get("ListViewer.LoggedOnAs", new String [] {linkUser+"<u>"+context.getUserID()+"</u></a>&nbsp;", linkSys+" <u>"+ context.getSystemGroup()+"</u></a>"})%>
</div>

<!-- Create the heading for the list table ---------------------->
<div class="title">
  <%if (type == SessionContext.LISTS) {%>
    <%=context.get("ListViewer.ListsHeader", String.valueOf(count))%> &nbsp;
  <%} else {%>
    <%=context.get("ListViewer.Of", new String[] { distype, list.name() })%> &nbsp;(<%=count%>)
  <%}%>
  <br><br>
</div>

<table border="2" bordercolordark="#000000" bordercolorlight="#FFFFFF" cellspacing="0" cellpadding="5" width="100%" class="listtable">
<tr><td>
<table border="0" cellspacing="0" cellpadding="0" width="100%" class="listtable">
<tr>
 <th align="left" width="5%"><%=context.get("ListViewer.Action")%>&nbsp;&nbsp;</th>
 <%if (type != SessionContext.TEMPLATELIST && type != SessionContext.LISTS)
 {%>
   <th align="left" width="1%"><b><%=context.get("ListViewer.State")%>&nbsp;&nbsp;</b></th>
 <%}%>
 <%if (type == SessionContext.LISTS)
 {%><th align="left" width="10%"><b><%=context.get("ListViewer.KindOfList")%>&nbsp;&nbsp;</b></th>
 <%}%>
 <th align="left" width="20%"><b><%=context.get("ListViewer.Name")%>&nbsp;&nbsp;</b></th>
 <%if (type != SessionContext.LISTS)
   {%><th align="left" width="5%">&nbsp;</th> <!-- Properties button --><%}%>
 <%if (type == SessionContext.WORKLIST) {%>
   <th align="left" width="30%"><b>&nbsp;<%=context.get("ListViewer.Description")%>&nbsp;&nbsp;</b></th>
   <th align="left" width="15%"><b><%=context.get("ListViewer.ProcessInstance")%>&nbsp;&nbsp;</b></th>
 <%} if (type == SessionContext.WORKLIST || type == SessionContext.LISTS) {%>
 <th align="left" width="9%"><b><%=context.get("ListViewer.Owner")%>&nbsp;&nbsp;</b></th>
 <%} if (type == SessionContext.WORKLIST) {%>
 <th align="left" width="15%"><b><%=context.get("ListViewer.Received")%>&nbsp;&nbsp;</b></th>
 <%}
   else
   {%>
 <th align="left" width="30%"><b>&nbsp;<%=context.get("ListViewer.Description")%>&nbsp;&nbsp;</b></th>
   <%if (type == SessionContext.INSTANCELIST){%>
 <th align="left" width="20%"><b><%=context.get("ListViewer.LastModified")%>&nbsp;&nbsp;</b></th>
 <%  }
  }%>
</tr>
<!-- Define the Action Icons -->
<%
  String imageAttr = "border=\"0\" width=\"22\" height=\"22\"";
  String propImage =
    "<img src=\"../images/action/properties.gif\" " + imageAttr +
    " alt=\"" + context.get("ListViewer.Properties") + "\">";
  String settingsImage = propImage;
  String row[] = { "oddrow", "evenrow" };
%>


<!-- Now create the list of instances ---------------------------->
<tr><td width="100%" colspan="8"><hr></td></tr>
<%if (type == SessionContext.INSTANCELIST)
    for (int i = 0; i < count; ++i)
    {
      try
      {
        ProcessInstance instance = context.getInstances()[i];
        String oid = instance.persistentOid();
        String name = instance.name();
        Command[] cmds = Command.getActions(instance);
        %>
      <tr class="<%=row[i % row.length]%>">
      <td nowrap><%
      if (cmds.length == 0)
        {%>&nbsp;<%}
      else for (int j = 0; j < cmds.length; ++j)
        {%><%=cmds[j].getTriggerTag(context, oid, name)%><%}%></td>

      <td nowrap align="center">
      <img src="../images/state/<%=context.getPIImageForState(instance.state())%>"
           alt="<%=context.getPIStringForState(instance.state())%>"></td>

      <td nowrap>
        &nbsp;<%=instance.name()%></td>

      <%context.setInstance(instance);%>
      <td nowrap>
        <a href="<%=context.getCommand("showInstanceProperties", instance.persistentOid())%>"><%=propImage%></a><%=context.getTriggerTagFor(SessionContext.INSTANCELIST, context)%></td>

      <td nowrap>
        &nbsp;<%=context.null2Empty(instance.description())%>
      </td>

      <td nowrap>
        <%=context.toString(instance.lastModificationTime())%>&nbsp;</td>
      </tr>
    <%}
      catch(FmcException xcpt) {
        if (xcpt.rc != FmcException.FMC_ERROR_DOES_NOT_EXIST) throw xcpt;
      }
    } /* End of for ----------- Process Instances ----------- */

  else if (type == SessionContext.TEMPLATELIST)
    for (int i = 0; i < count; ++i)
    {
      ProcessTemplate template = context.getTemplates()[i];
      String oid = template.persistentOid();
      String name = template.name();
      Command[] cmds = Command.getActions(template); %>

      <tr class="<%=row[i % row.length]%>">

      <td nowrap><%
      if (cmds.length == 0)
        {%>&nbsp;<%}
      else for (int j = 0; j < cmds.length; ++j)
        {%><%=cmds[j].getTriggerTag(context, oid, name)%><%}%></td>

      <td nowrap>
        &nbsp;<%=name%></td>

      <td nowrap>
        <%context.setTemplate(template); %>
        <a href="<%=context.getCommand("showTemplateProperties", oid)%>"><%=propImage%></a><%=context.getTriggerTagFor(SessionContext.TEMPLATELIST, context)%></td>

      <td nowrap>
        &nbsp;<%=context.null2Empty(template.description())%>
      </td>

      </tr>
  <%} /* End of for ----------- Process Templates ----------- */

  else if (type == SessionContext.WORKLIST)
  {
    Config  cfg      = context.getConfig();
    boolean viaEmail = cfg.getParameter("SMTP", "Host") != null;     // A configured SMTP host triggers email enablement

    int cpn = context.getProcessInstanceNotifications().length;
    int can = context.getActivityInstanceNotifications().length;
    int cwi = context.getWorkItems().length;

    for (int i = 0; i < count; i++)
    {
      try
      {
        ProcessInstanceNotification processNotification = null;
        ActivityInstanceNotification activityNotification = null;
        WorkItem workItem = null;

        Item item = null;
        Command[] cmds = null;

        if (i < cpn)
        {
          item = processNotification =
             context.getProcessInstanceNotifications()[i];
          cmds = Command.getActions(processNotification);
        }
        else if (i < cpn + can)
        {
          item = activityNotification =
             context.getActivityInstanceNotifications()[i - cpn];
          cmds = Command.getActions(activityNotification);
        }
        else
        {
          item = workItem = context.getWorkItems()[i - cpn - can];
          cmds = Command.getActions(user, workItem);
        }

        String oid = item.persistentOid();
        String name = item.name();
      %>

      <tr class="<%=row[i % row.length]%>">

      <td nowrap><%
      if (cmds.length == 0)
        {%>&nbsp;<%}
      else for (int j = 0; j < cmds.length; ++j)
      {
        if (!"transferItem".equals(cmds[j].getCommand()))
          %><%=cmds[j].getTriggerTag(context, oid, name)%><%
        else if (!viaEmail)
          %><%=cmds[j].getTriggerTag(context, oid, user)%><%
        else
        {
//          String url = "javascript:{}\" onClick=\"javascript: var xfer = window.open('','Transfer_Item','width=400,height=190,screenX=100,screenY=100,dependent=yes,resizable=yes, menubar=yes, status=yes');" +
          String url = "javascript:{}\" onClick=\"javascript: var xfer = window.open('','Transfer_Item','width=400,height=190,screenX=100,screenY=100,dependent=yes,resizable=yes');" +
                       " fillForm(xfer.document, '" + name + "', '" + item.owner() +
                                  "', '" + user + "', '" +
                                  context.getCommand("x-transferItem", oid) +
                                  "', '" + viaEmail + "');";
          %><a href="<%=url%>"><%=cmds[j].getActionIcon(context, imageAttr)%></a><%
        }
      }%></td>

      <td nowrap align="center">
        <img src="../images/state/<%=context.getPIImageForState(item.processInstanceState())%>"
             alt="<%=context.getPIStringForState(item.processInstanceState())%>">
      <% if (workItem != null) {
      %><img src="../images/state/<%=context.getWIImageForState(workItem.state())%>"
             alt="<%=context.getWIStringForState(workItem.state())%>">
      <% } else {
      %><img src="../images/state/<%=context.getImageForItem(item.kind())%>"
             alt="<%=context.toString(item.kind())%>">
      <% }%></td>

      <td nowrap>
        &nbsp;<%=name%>&nbsp;</td>

      <td nowrap>
      <%context.setWorkItem(workItem);
        context.setItem(item);
        String customTags = context.getTriggerTagFor(SessionContext.WORKLIST, context);
        if (workItem != null) {
      %><a href="<%=context.getCommand("showWorkItemProperties", oid)%>"><%=propImage%></a><%=customTags%></td>
      <% } else if (processNotification != null) {
      %><a href="<%=context.getCommand("showInstanceProperties", processNotification.persistentOidOfProcessInstance())%>"><%=propImage%></a><%=customTags%></td>
      <% } else if (activityNotification != null) {
      %><a href="<%=context.getCommand("showActivityProperties", activityNotification.persistentOidOfActivityInstance())%>"><%=propImage%></a><%=customTags%></td>
      <% } else {
      %></td>
      <% }%>

      <td nowrap>
        &nbsp;<%=context.null2Empty(item.description())%>
      </td>

      <td nowrap>
        <%=item.processInstanceName()%>&nbsp;</td>

      <td nowrap>
        <%=item.owner()%>&nbsp;</td>

      <td nowrap>
        <%=context.toString(item.creationTime())%></td>

      </tr>
    <%}
      catch (FmcException xcpt)
      {
        if (xcpt.rc != xcpt.FMC_ERROR_DOES_NOT_EXIST) throw xcpt; %>
        <td>&nbsp;</td>
        <td align="center">
          <img src="../images/state/<%=context.getWIImageForState(com.ibm.workflow.api.ItemPackage.ExecutionState.DELETED)%>"
               width="16" height="16" alt="<%=context.getWIStringForState(com.ibm.workflow.api.ItemPackage.ExecutionState.DELETED)%>"></td>
        <td><b>(n/a)</b></td>
        <td>&nbsp;</td>
        <td><b><%=context.get("ListViewer.ItemHasBeenDeleted")%></b></td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
    <%}
    } /* End of for ----------- Work Items ----------- */
  }
  else if (type == SessionContext.LISTS)
  {%>

  <tr class="<%=row[0]%>">
     <td><a href="<%=context.getCommand("createList")%>"><img src="../images/action/create_list.gif" border="0" alt="<%=context.get("ListViewer.CreateAList")%>"></a></td>
     <td><%=context.get("ListViewer.CreateAList")%></td>
     <td>&nbsp; </td>
     <td>&nbsp; </td>
     <td>&nbsp; </td>
  </tr>
  <tr>
    <td colspan="5"><hr></td>
  </tr>

  <%Enumeration wLists = context.getWorkLists();
    Enumeration piLists = context.getInstanceLists();
    Enumeration ptLists = context.getTemplateLists();
    int wil = context.getNumberOfWorkLists();
    int pil = context.getNumberOfInstanceLists();
    int ptl = context.getNumberOfTemplateLists();

    for (int i = 0; i < count; i++)
    {
      try
      {
        WorkList wList = null;
        ProcessInstanceList piList = null;
        ProcessTemplateList ptList = null;

        PersistentList persList = null;
        Command[] cmds = null;
        String kindOfList="";

        if (i < wil)
        {
          persList = wList = (WorkList) wLists.nextElement();
          kindOfList=context.get("ListViewer.Worklist");
        }
        else if (i < wil + pil)
        {
          persList = piList = (ProcessInstanceList) piLists.nextElement();
          kindOfList=context.get("ListViewer.ProcessInstanceList");
        }
        else
        {
          persList = ptList = (ProcessTemplateList) ptLists.nextElement();
          kindOfList=context.get("ListViewer.ProcessTemplateList");
        }

        cmds = Command.getActions(persList);
        String name = persList.name();
        String oid = context.persistentOidOf(persList);
      %>

      <tr class="<%=row[(i + 1) % row.length]%>">

      <td nowrap><%
      if (cmds.length == 0)
        {%>&nbsp;<%}
      else for (int j = 0; j < cmds.length; ++j)
      {%><%=cmds[j].getTriggerTag(context, oid, name)%><%}

      %></td>

      <td nowrap>
        &nbsp;<%=kindOfList%>&nbsp;</td>

      <td nowrap>
        <%String command="";
        if (wList != null) command = Command.WL_QUERY_WORK_ITEMS.getURL(context, oid, null, false);
        else if (piList != null) command = Command.PIL_QUERY_INSTANCES.getURL(context, oid, null, false);
        else if (ptList != null) command = Command.PTL_QUERY_TEMPLATES.getURL(context, oid, null, false);
         %>
        &nbsp;<a href="<%=command%>"><%=name%></a>&nbsp;</td>

      <td nowrap>
        <%=context.null2Empty(persList.ownerOfList())%>
      </td>

      <td nowrap>
        &nbsp;<%=context.null2Empty(persList.description())%>
      </td>

      </tr>
    <%}
      catch (FmcException xcpt)
      {
        if (xcpt.rc != xcpt.FMC_ERROR_DOES_NOT_EXIST) throw xcpt; %>
        <td>&nbsp;</td>
        <td align="center">
          <img src="../images/state/<%=context.getWIImageForState(com.ibm.workflow.api.ItemPackage.ExecutionState.DELETED)%>"
               width="16" height="16" alt="<%=context.getWIStringForState(com.ibm.workflow.api.ItemPackage.ExecutionState.DELETED)%>"></td>
        <td><b>(n/a)</b></td>
        <td>&nbsp;</td>
        <td><b><%=context.get("ListViewer.ItemHasBeenDeleted")%></b></td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
    <%}
    } /* End of for ----------- List of Lists ----------- */

  } %>
</table>

</td></tr></table>

</body></html>
