<!-- BEGIN CMVC                                                              -->
<!-- *********************************************************************** -->
<!--                                                                         -->
<!--   Workfile: %W%                                                         -->
<!--   Last update: %E% %U%                                                  -->
<!--   SCCS path, id: %F% %I%                                                -->
<!--                                                                         -->
<!-- *********************************************************************** -->
<!-- END CMVC                                                                -->
<!-- BEGIN COPYRIGHT                                                         -->
<!-- *********************************************************************** -->
<!--                                                                         -->
<!--   Licensed Materials - Property of IBM                                  -->
<!--   WA81 SupportPac                                                       -->
<!--   (c) Copyright IBM Corp. 1999, 2001                                    -->
<!--   US Government Users Restricted Rights - Use, duplication or           -->
<!--   disclosure restricted by GSA ADP Schedule Contract                    -->
<!--   with IBM Corp.                                                        -->
<!--                                                                         -->
<!-- *********************************************************************** -->
<!-- END COPYRIGHT                                                         -->

<%-- Import the context bean that will be passed by the servlet --%>
<%-- Note that the scope of that bean is a single request, not  --%>
<%-- the entire session                                         --%>
<%@ page language="java" info="JSP User Info Viewer" %>
<%@ page errorPage="ViewError.jsp" %>
<%@ page import="com.ibm.workflow.api.*" %>
<%@ page import="com.ibm.workflow.servlet.client.*" %>
<jsp:useBean id="context" scope="request"
             type="com.ibm.workflow.servlet.client.RequestContext"/>

<%Person person = context.getExecutionService().userSettings();
  String personID = context.null2Empty(person.personID());
  String firstName = context.null2Empty(person.firstName());
  String lastName = context.null2Empty(person.lastName());
  String middleName =context.null2Empty(person.middleName());
  String phone = context.null2Empty(person.phone());
  String secondPhone = context.null2Empty(person.secondPhone());
  String level = new Integer(person.level()).toString();
  String absent = (person.isAbsent()) ? "checked" : "";
  String manager = context.null2Empty(person.manager());
  String isManager= (person.isManager()) ? "checked" : "unchecked";
  String organizationName = context.null2Empty(person.organizationName());
  String namesOfRoles=context.formatStringArray(person.namesOfRoles(),"<br>");
  String namesOfRolesToCoordinate=context.formatStringArray(person.namesOfRolesToCoordinate(),"<br>");
  String isAuthorizedForStaffDefinition= (person.isAuthorizedForStaffDefinition()) ? "checked" : "unchecked";
  String isAuthorizedForOtherDefinition= (person.isAuthorizedForAuthorizationDefinition() || person.isAuthorizedForProcessDefinition() || person.isAuthorizedForTopologyDefinition()) ? "checked" : "unchecked";
  String categoriesAuthorizedFor=context.formatStringArray(person.categoriesAuthorizedFor(),"<br>");
  String isAuthorizedForAllCategories= (person.isAuthorizedForAllCategories()) ? "checked" : "unchecked";
  String isAuthorizedForAllPersons= (person.isAuthorizedForAllPersons()) ? "checked" : "unchecked";
  String personsAuthorizedForMe=context.formatStringArray(person.personsAuthorizedForMe(),"<br>");
  String substitute = (person.substitute()!=null) ? person.substitute() : "";
  String personsToStandInFor=context.formatStringArray(person.personsToStandInFor(),"<br>");
  String personsAuthorizedFor=context.formatStringArray(person.personsAuthorizedFor(),"<br>");
  String description=context.null2Empty(person.description());
  description=context.replaceInString(description, "\r\n", "<br>");
  description=context.replaceInString(description, "\n", "<br>");
  description=context.replaceInString(description, "\r", "<br>");
  description=context.replaceInString(description,  "\"", "\\\"");
%>
<html>
<head>
<title>IBM MQSeries Workflow Web Client - <%=context.get("UserInfoViewer.Title")%></title>
<link rel="stylesheet" type="text/css" href="../webclientstyle.css">
<link rel="stylesheet" type="text/css" href="../webclientstyle.css">
<style type="text/css">
  a
  {
    color: #000000;
    text-decoration: none;
  }
  a:hover
  {
    color: #000000;
    text-decoration: underline;
  }
  td
  {
    font-size   :9pt;
    font-family :Arial, Helvetica, sans-serif;
    font-weight :bold;
  }
  blockquote
  {
    padding-left     :0.5cm;
    padding-right    :0.5cm;
  }
</style>

<script language="JavaScript" src="../dhtml.js"></script>
<script language="Javascript">
  var tabtext   = new Array("<%=context.get("UserInfoViewer.General")%>",
                        "<%=context.get("UserInfoViewer.Assignments")%>",
                        "<%=context.get("UserInfoViewer.Authorization")%>",
                        "<%=context.get("UserInfoViewer.Substitution")%>",
                        "<%=context.get("UserInfoViewer.Description")%>")

</script>
</head>
<body onLoad="javascript:initTabedPane(0)">

<%String command="", id="", buttonTxt=context.get("Command.Back"), imagename="", addl="";
  if (context.getKindOfList()==SessionContext.WORKLIST)
  {
    command = "queryWorkItems";
    id = context.getWorkListOid();
    imagename = "back_worklist";
    buttonTxt = context.get("Viewer.BackToWorklist");
  }
  else if (context.getKindOfList()==SessionContext.INSTANCELIST)
  {
    command = "queryProcessInstances";
    id = context.getInstanceListOid();
    imagename = "back_instlist";
    buttonTxt = context.get("Viewer.BackToInstancelist");
  }
  else if (context.getKindOfList()==SessionContext.TEMPLATELIST)
  {
    command = "queryProcessTemplates";
    id = context.getTemplateListOid();
    imagename = "back_templist";
    buttonTxt = context.get("Viewer.BackToTemplatelist");
  }
  else if (context.getKindOfList()==SessionContext.LISTS)
  {
    command = "queryLists";
    imagename = "back";
    buttonTxt = context.get("Viewer.BackToLists");
  }
%>
<!-- --------------- Navigation Buttons --------------- //-->

<table width="100%" border="2" bordercolordark="#000000" bordercolorlight="#FFFFFF" cellpadding="0" cellspacing="0" class="navigator">
<tr>
    <!--  Back to List Button  //-->
    <td align="left">
      <a href="<%=context.getCommand(command, id, "&useCache=true")%>">
      <img src="../images/navigation/<%=imagename%>.gif" border="0" alt="<%=buttonTxt%>"></a></td>


<!--  Refresh Button  //-->
    <td align="left">
      <a href="<%=context.getCommand("getUserInfo")%>"><img src="../images/navigation/refresh.gif" border="0" alt="<%=context.get("Command.Refresh")%>"></a></td>

    <td width="100%">&nbsp;</td>

    <td>
     <a href="javascript:{}" onClick="javascript:var helpwin=window.open('../help/Help_index.html','Help','width=600,height=500,screenX=200,screenY=0,scrollbars,resizable');helpwin.frames[1].location.replace('../help/Help_Body.html#CreateList');">
     <img src="../images/navigation/help.gif" border="0" alt="<%=context.get("UserInfoViewer.Help")%>"></a></td>

    <td class="navigationseparator"><img src="../images/a_pixel.gif" width="3"></td>

    <td align="right">
     <a href="<%=context.getCommand("logoff")%>">
     <img src="../images/navigation/logoff.gif" border="0" alt="<%=context.get("UserInfoViewer.Logoff")%>"></a></td>

  </tr>
  </table>

<!-- Title -->
  <br>
  <div width="100%" class="title"><%=context.get("UserInfoViewer.Title")%></div>

<!-- Tab Contexts till End of Code -->
<div id="<%=context.get("UserInfoViewer.General")%>" class="tabbody">
<br>
  <table border="0" cellspacing="8" cellpadding="2" width="420">
     <colgroup>
        <col width="85">
        <col width="125">
        <col width="8">
        <col width="85">
        <col width="125">
     </colgroup>
  <tr>
    <td><%=context.get("UserInfoViewer.UserID")%></td>
    <td class="informationfield"><%=person.userID()%></td>
    <td>&nbsp;</td>
    <td><%=context.get("UserInfoViewer.PersonID")%></td>
    <td class="informationfield" width="100"><%=personID%></td>
  </tr>
  <tr>
    <td><%=context.get("UserInfoViewer.FirstName")%></td>
    <td class="informationfield"><%=firstName%></td>
    <td></td>
    <td><%=context.get("UserInfoViewer.LastName")%></td>
    <td class="informationfield"><%=lastName%></td>
  </tr>
  <tr>
    <td><%=context.get("UserInfoViewer.Level")%></td>
    <td class="informationfield"><%=level%></td>
    <td></td>
    <td><%=context.get("UserInfoViewer.MiddleName")%></td>
    <td class="informationfield"><%=middleName%></td>
  </tr>
  <tr>
    <td colspan="5"><hr></td>
  </tr>
  <tr>
    <td><%=context.get("UserInfoViewer.Phone1")%></td>
    <td class="informationfield"><%=phone%></td>
    <td></td>
    <td><%=context.get("UserInfoViewer.Phone2")%></td>
    <td class="informationfield"><%=secondPhone%></td>
  </tr>
  <tr>
    <td colspan="5"><hr></td>
  </tr>
  </table>
  <form>
  <table border="0" cellspacing="8" cellpadding="2" width="420">
  <tr>
    <td colspan="5">
    <label>
      <input type="checkbox" name="Absent" value="Absent" <%=absent%>> <%=context.get("UserInfoViewer.Absent")%>
    </label>
    </td>
  </tr>
  <tr>
    <label>
      <td width="120" colspan="2"><%=context.get("UserInfoViewer.NewPassword")%><br>
      <input type="password" name="NewPassword"></td>
    </label>
    <td width="85">&nbsp;</td>
    <label>
      <td width="120" align="left"><%=context.get("UserInfoViewer.VerifyPassword")%><br>
      <input type="password" name="VerifyPassword"></td>
    </label>
  </tr>
  <tr>
    <td align="right" colspan="4">
      <input name="command" type="hidden" value="setUserSettings">
      <input type="submit" value="<%=context.get("UserInfoViewer.Apply")%>">&nbsp;
      <input type="reset" value="<%=context.get("UserInfoViewer.Reset")%>"></td>
    <td widht="30">&nbsp;</td>
  </tr>
  <br>
 </table>
 </form>


</div>

<div id="<%=context.get("UserInfoViewer.Assignments")%>" class="tabbody">
<br>
  <table border="0" cellspacing="8" cellpadding="2" width="420">
  <tr>
    <td width="70"><%=context.get("UserInfoViewer.Manager")%></td>
    <td width="100" class="informationfield"><%=manager%></td>
    <td width="50"></td>
    <td width="5"><img src="../images/<%=isManager%>.gif" border="0"></td>
    <td width="150"><%=context.get("UserInfoViewer.YouAreManager")%></td>
  </tr>
  <tr>
    <td width="70"><%=context.get("UserInfoViewer.Organization")%></td>
    <td width="255" class="informationfield" colspan="4"><%=organizationName%></td>
  </tr>
  <tr>
    <td colspan="5"><hr></td>
  </tr>
  </table>
  <table border="0" cellspacing="8" cellpadding="2" width="420">
  <tr>
    <td width="185"><%=context.get("UserInfoViewer.YourRoles")%></td>
    <td width="185"><%=context.get("UserInfoViewer.RolesYouCoordinate")%></td>
  </tr>
  <tr>
    <td class="informationfield" height="100"><%=namesOfRoles%></td>
    <td class="informationfield" height="100"><%=namesOfRolesToCoordinate%></td>
  </tr>
  </table>
</div>

<div id="<%=context.get("UserInfoViewer.Authorization")%>" class="tabbody">
<br>
  <table border="0" cellspacing="6" cellpadding="1" width="420">
  <tr>
    <td width="185" colspan="2"><%=context.get("UserInfoViewer.Functions")%></td>
    <td width="185"><%=context.get("UserInfoViewer.Categories")%></td>
  </tr>
  <tr>
    <td width="1"></td>
    <td><img src="../images/<%=isAuthorizedForStaffDefinition%>.gif" border="0">&nbsp;<%=context.get("UserInfoViewer.StaffDefinition")%></td>
    <td rowspan="2" class="informationfield"><%=categoriesAuthorizedFor%></td>
  </tr>
  <tr>
    <td width="1"></td>
    <td><img src="../images/<%=isAuthorizedForOtherDefinition%>.gif" border="0">&nbsp;<%=context.get("UserInfoViewer.OtherDefinition")%></td>
  </tr>
  <tr height="10">
    <td width="185" colspan="2"><hr></td>
    <td width="185"><img src="../images/<%=isAuthorizedForAllCategories%>.gif" border="0">&nbsp;<%=context.get("UserInfoViewer.AllCategories")%></td>
  </tr>
  <tr>
    <td colspan="2"><%=context.get("UserInfoViewer.YouCanAccessWorkItemsOf")%></td>
    <td><hr></td>
  </tr>
  <tr>
    <td colspan="2"><img src="../images/<%=isAuthorizedForAllPersons%>.gif" border="0">&nbsp;<%=context.get("UserInfoViewer.WorkItemsOfAllPeople")%></td>
    <td><%=context.get("UserInfoViewer.PeopleWhoCanAccessYourWorklist")%></td>
  </tr>
  <tr>
    <td colspan="2" height="80" class="informationfield"><%=personsAuthorizedFor%></td>
    <td class="informationfield"><%=personsAuthorizedForMe%></td>
  </tr>
  </table>
</div>

<div id="<%=context.get("UserInfoViewer.Substitution")%>" class="tabbody">
<form>
<br>
  <table border="0" cellspacing="6" cellpadding="1" width="420">
  <tr>
    <label>
    <td width="150"><%=context.get("UserInfoViewer.YourSubstitute")%><br>
    <input type="text" name="Substitute" value="<%=substitute%>"></td>
    </label>
  </tr>
  <tr>
    <td width="150"><%=context.get("UserInfoViewer.YouSubstitute")%></td>
    <td width="60"></td>
    <td width="150"><%=context.get("UserInfoViewer.YouAreAuthorizedFor")%></td>
  </tr>
  <tr>
    <td class="informationfield" height="140"><%=personsToStandInFor%></td>
    <td width="60"></td>
    <td class="informationfield"><%=personsAuthorizedFor%></td>
  </tr>
  <tr>
    <td align="right" colspan="4">
      <input name="command" type="hidden" value="setUserSettings">
      <input type="submit" value="<%=context.get("UserInfoViewer.Apply")%>">&nbsp;
      <input type="reset" value="<%=context.get("UserInfoViewer.Reset")%>"></td>
  </tr>
  </table>
  <br>
</form>
</div>

<div id="<%=context.get("UserInfoViewer.Description")%>" class="tabbody">
  <br>
  <table width="420">
  <tr>
    <td width="100%"><%=context.get("UserInfoViewer.Description")%></td>
  </tr>
  <tr>
    <td class="informationfield" height="180"><%=description%></td>
  </tr>
  </table>
  <br>
</div>
</body>
</html>
