<?xml version='1.0'?>

<xsl:stylesheet
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        version    = '1.0'>

<xsl:include href="navigation-wml-palm.xsl"/>

<!-- ========================================================= -->
<!-- the RequestContext as the main tag being processed           -->
<!-- ========================================================= -->
<xsl:template match='RequestContext'>

  <!-- ========================================================= -->
  <!-- the main card for workitems/templates/instances           -->
  <!-- ========================================================= -->
  <card><xsl:attribute name="title"><xsl:value-of select='WorkList/Name'/></xsl:attribute>
    <template>
      <do label="Lists" type="accept" name="lists"><go href="#lists"/></do>
    </template>
    <p>
        <!-- ========================================================= -->
        <!-- show the workItems if there are any (regarding threshold) -->
        <!-- ========================================================= -->
      <xsl:variable name="threshold"><xsl:value-of select='number(WorkList/Threshold)'/></xsl:variable>
      <xsl:for-each select='WorkList/WorkItem'>
        <xsl:if test='position() &lt;= 6'>
          <xsl:if test='position() &lt;= $threshold'>
            <anchor><xsl:value-of select='Description'/>
              <go href="#options">
                <setvar name="item_oid"><xsl:attribute name="value"><xsl:value-of select='PersistentOid'/></xsl:attribute></setvar>
              </go>
            </anchor><br/>
          </xsl:if>
        </xsl:if>
      </xsl:for-each>
    </p>
  </card>


 <!-- ========================================================= -->
 <!-- the options card                                          -->
 <!-- ========================================================= -->
  <card id="options" title="WorkItem">
    <template>
      <do label="Back" type="prev" name="back"><prev/></do>
    </template>
    <p mode="nowrap">
      <anchor>show properties
        <go href="/MQWFClient/servlet/Main">
          <postfield name="command" value="showWorkItemProperties"/>
          <postfield name="id" value="$(item_oid)"/>
        </go>
      </anchor><br/>
      <anchor>Check out
        <go href="/MQWFClient/servlet/Main">
          <postfield name="command" value="checkOutWorkItem"/>
          <postfield name="id" value="$(item_oid)"/>
          <postfield name="startAllowed" value="true"/>
        </go>
      </anchor><br/>
      <anchor>Transfer
        <go href="/MQWFClient/servlet/Main">
          <postfield name="command" value="transferWorkItem"/>
          <postfield name="id" value="$(item_oid)"/>
        </go>
      </anchor><br/>
      <anchor>CancelWorkitem
        <go href="/MQWFClient/servlet/Main">
          <postfield name="command" value="cancelWorkItem"/>
          <postfield name="id" value="$(item_oid)"/>
        </go>
      </anchor>
    </p>
  </card>

</xsl:template>

</xsl:stylesheet>
