/*BEGIN CMVC */
//*************************************************************************
//
//  Workfile: %W%
//  Last update: %E% %U%
//  SCCS path, id: %F% %I%
//
//************************************************************************/
/*END CMVC */
/*BEGIN COPYRIGHT */
//*************************************************************************
//
//  Licensed Materials - Property of IBM
//  WA81 SupportPac
//  (c) Copyright IBM Corp. 1999, 2001
//  US Government Users Restricted Rights - Use, duplication or
//  disclosure restricted by GSA ADP Schedule Contract
//  with IBM Corp.
//
//************************************************************************/
/*END COPYRIGHT */
/*BEGIN DISCLAIMER */
//*************************************************************************
//  DISCLAIMER
//  ----------
//  This material contains programming source code for your consideration.
//  These examples have not been thoroughly tested under all conditions.
//  IBM, therefore, cannot guarantee or imply reliability, serviceability,
//  or function of these programs.
//  ALL PROGRAMS CONTAINED HEREIN ARE PROVIDED TO YOU "AS IS", WITHOUT ANY
//  WARRANTIES (EXPRESS OR IMPLIED) OR SUPPORT WHATSOEVER, INCLUDING BUT
//  NOT LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS
//  FOR A PARTICULAR PURPOSE.
//************************************************************************/
/*END DISCLAIMER */

package com.ibm.workflow.servlet.sample;

import com.ibm.workflow.servlet.client.*;

/**
* <p>This Viewer provides a condensed client suitable for Portals where
* only little space is available per channel.</p>
*/
public class PortletViewer extends JSPViewer
{
  /**
  * Creates the page that is displayed after a successful logon.
  * In contrast to the 'normal' Web Client, the first page after logon
  * is a list of lists.
  * @param context The request context.
  * @return The response page.
  * @exception ClientException if an error occurred
  */
  public ResponsePage logonResponse(RequestContext context)
                      throws ClientException
  {
    // fill the SessionContext cache with the available lists
    BuiltinHandler builtin = context.getBuiltinHandler();
    builtin.queryProcessTemplateLists(context);
    builtin.queryProcessInstanceLists(context);
    builtin.queryWorkLists(context);

    return new ResponsePage(context, "/forms/PortletMain.jsp");
  }

  /**
  * This method is called to create the response page for the
  * {@link BuiltinHandler#queryWorkItems BuiltinHandler.queryWorkItems()} command.
  * @param context The request context.
  * @return The response page.
  * @exception com.ibm.workflow.servlet.client.ClientException If an error occurred.
  */
  public ResponsePage queryWorkItemsResponse(RequestContext context)
                      throws ClientException
  {
    return new ResponsePage(context, "/forms/PortletList.jsp");
  }
}
